#!/bin/bash

# Required executables:
LOGGER="/usr/bin/logger"
SERVICE="/sbin/service"
KILLALL="/usr/bin/killall"
IFCONFIG="/sbin/ifconfig"
SYNC="/bin/sync"

TO_NULL=" &> /dev/null"

function die {
	(sleep 30; reboot) &
	logger -t $0 " -- FAILURE. Rebooting in 30 seconds..."
	exit 1
}

##################################################################
# n. Make sure all of the commands we need are executable
##################################################################

for i in $LOGGER $SERVICE $KILLALL $IFCONFIG $SYNC
do
	if [ ! -x $i ]
	then
		# try our best:
		logger -t $0 "Required command ($i) is missing or NOT executable!"
		die
	fi
done

LOGGER="$LOGGER -t $0"

##################################################################
# n. clear up any space we can...
##################################################################

#$SERVICE ipsec stop &> /dev/null
$KILLALL -9 pluto &> /dev/null
$SERVICE openvpn stop &> /dev/null
$SERVICE ripd stop &> /dev/null
$SERVICE ospfd stop &> /dev/null
$SERVICE bgpd stop &> /dev/null
$SERVICE zebra stop &> /dev/null
$KILLALL -9 dnsmasq &> /dev/null
$KILLALL -USR2 jbminit &> /dev/null
$SERVICE xinetd stop &> /dev/null
$SERVICE jbmconfig stop &> /dev/null
$SERVICE jbmconfigs stop &> /dev/null
$IFCONFIG eth0 down &> /dev/null
$IFCONFIG eth1 down &> /dev/null
$KILLALL pppd &> /dev/null
$SYNC
echo 3 > /proc/sys/vm/drop_caches

exit

